<?php
defined("_JEXEC") or die("Restricted Access");

class plgFlexicontent_fieldsSigalleryuploader extends JPlugin{

	function plgFlexicontent_fieldsSigalleryuploader( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		JPlugin::loadLanguage('plg_flexicontent_fields_sigalleryuploader', JPATH_ADMINISTRATOR);
	}


	function onDisplayField(&$field, $item)
	{

		if($field->field_type != 'sigalleryuploader'){
			return;
		}
		else{
			$field->html = "<label>Gallery Name</label>
			<input type='text' name='".$field->name."[gallery]' value='" . @$field->value[0] . "' size='40'/><br/>";
			$field->html .= 'Upload Zip File <input type="file" name="'.$field->name.'" id="'.$field->name.'_zip_file">';
		}
	}


	/*function onBeforeSaveField($field, &$post, $file)
	{
		if($field->field_type != 'sigalleryuploader') return;
	}*/

	public function onAfterSaveField($field, &$post, $file)
	{
		if($field->field_type != 'sigalleryuploader')
		{
			return;
		}
		
		$jAp=& JFactory::getApplication();
		jimport("joomla.application.component.controller");
		jimport('joomla.filesystem.folder');
		jimport("joomla.filesystem.file");
		jimport('joomla.filesystem.archive');
		
		$image_folder = $field->parameters->get('dir_path', 'images/stories');
		$gallery_name = $post['gallery'];
		
		// Check filename and gallery name
		if( trim($file['name'])=="" )
		{
			return;  // nothing to do, no file was specified
		}
		else if( empty($gallery_name) )
		{
			$jAp->enqueueMessage('Please set a gallery name for field: '.$field->label.' Archive file was not extracted', 'notice');
			return;
		}
		
		// Check for ZIP file extension
		if ( JFile::getExt($file["name"]) != "zip" )
		{
			$jAp->enqueueMessage('Please select an ZIP archive file for field: '.$field->label.' Archive file was not extracted', 'notice');
			return;
		}
		
		// Uploading the zip file in new temporary folder
		$path_to_tmp = JPATH_SITE.DS."tmp" . DS . "tmp" .time()."_".rand();
		$safe_name   = JFile::makeSafe($file['name']);
		$des_zip     = $path_to_tmp.DS.$safe_name;
		
		// Upload the file
		if ( !JFile::upload($file['tmp_name'], $des_zip) ) {
			$jAp->enqueueMessage('File could not be uploaded for field : '.$field->label.' Archive file was not extracted', 'error');
			return;
		} else {
			JFile::write($path_to_tmp . DS . "index.html", "<html><body bgcolor='#FFFFFF'></body></html>");
		}
		
		// Extracting the uploaded zip file to temporary folder
		if ( !JArchive::extract($des_zip,$path_to_tmp) ) {
			$jAp->enqueueMessage('Extraction of uploaded archive file failed for field : '.$field->label, 'error');
			return;
		}

		// Deleting the uploaded zip file as we have extracted its contents
		JFile::delete($des_zip);
		$files_in_tmp = JFolder::files($path_to_tmp, ".", false, false, array("index.html"));
		// Validation for atlease one image file
		if(count($files_in_tmp) == 0){
			$jAp->enqueueMessage('No files found in uploaded archive file for field: '.$field->label, 'notice');
			JFolder::delete($path_to_tmp);
			return;
		}

		// Checking for images only
		$valid_images = array("jpeg","jpg","png","gif");
		foreach($files_in_tmp as $file_in_tmp){
			$files_in_tmp_type    = JFile::getExt($file_in_tmp);
			if(!in_array($files_in_tmp_type, $valid_images)){
				$jAp->enqueueMessage('No '.implode($valid_images,',').' IMAGE files found in uploaded archive file for field: '.$field->label, 'notice');
				JFolder::delete($path_to_tmp);
				return;
			}
		}

		// Creating the new folder to move image
		$gallery_path = $image_folder . DS . $gallery_name;
		$img_path     = JPATH_SITE . DS . $gallery_path;
		if (!JFolder::exists($img_path)){
			JFolder::create($img_path);
			JFile::write($img_path . DS . "index.html", "<html><body bgcolor='#FFFFFF'></body></html>");
		}

		// Moving images files in new folder
		foreach($files_in_tmp as $file_in_tmp){
			JFile::move($path_to_tmp.DS.$file_in_tmp, $img_path.DS.$file_in_tmp);
		}
		
		// Deleting the temporary folder
		JFolder::delete($path_to_tmp);
		
		// Notify user of successful extraction
		$jAp->enqueueMessage( sprintf('FIELD %s: Extracted %d image files into gallery folder %s', $field->label, count($files_in_tmp), $gallery_path), 'message');
	}
}
?>